/*****************************
 * ECE 4760: Final Project   *
 * Human Tetris              *
 * Video Arcade Edition      *
 *                           *
 * Adam Papamarcos (aip23)   *
 * Kerran Flanagan (kaf42)   *
 * Cornell University        *
 * Spring 2010               *
 *****************************/

#include <inttypes.h>

#ifndef LAB5_H_
#define LAB5_H_

// ============================== "PUBLIC" VARIABLES ==============================

// ---- NTSC Reading Stuff ----
// NTSC mode of OSD has 13 rows of 30 characters, we double up on rows and triple on cols
#define ROWS 39
#define COLS 60
#define NTSC_MIN 0x60
#define NTSC_MAX 0xF8

// Don't write to this outside of lab5.c.
uint8_t Input_Data[ROWS][COLS];

// ---- NTSC Output Stuff ----
uint8_t Black_Level;

uint8_t Output_Data[13][30];
uint8_t Output_Attributes[13][30];


char buffer[30];
uint8_t topL, midL, botL, topR, midR, botR;

#define LBC (0x01 << 7)
#define BLINK (0x01 << 6)
#define INVERT (0x01 << 5)

// ---- STATE STUFF ----

uint8_t ActiveMenuButton;
#define PlayTetris 1
#define PlayBrickBreaker 2
#define PlayMole 3
#define DoTracking 0


uint8_t GameState;
#define MENU 0
#define PLAYING_T 1
#define PLAYING_BB 2
#define PLAYING_MOLE 3
#define GAMEOVER 4
#define GAMEWIN 5
#define TRACKING 10

uint8_t *enterPushed, *togglePushed, *enterFlag, *toggleFlag;

// ---- TIME STUFF ----
#define TimePreScale 12500 //20MHz /8 / this = timer1 ISR rate = 200Hz, 5Ms timeBase
#define mps 30 //from NTSC Vertical Sync Pulses
uint16_t gameTimeMs;
uint8_t currentLevel;

// ---- OSD OUTPUT STUFF ----
#define PERSON_BLOCK_IN 224
#define PERSON_BLOCK_OUT 240

#define DOTS_BLANK 160

#define BLANK 0
#define WALL_BLOCK 89

#define MOLE_BLOCK_TOP 109
#define MOLE_BLOCK_BOT 125

#define BRICK 93
#define BRICK_CRACKED 80
#define BRICK_REALLY_CRACKED 83
#define BRICK_UNBREAKABLE 86
#define BALL_BLANK 96


// ========================== "PUBLIC" FUNCTION DECLARATIONS ==========================


void loadString(uint8_t x, uint8_t y, char *string);

void loadStringPrgm(uint8_t x, uint8_t y, char *string);

void loadFancyString(uint8_t x, uint8_t y, char *string, char attributes);

//set overWrite to 1 if blanks should be loaded instead of ignored
void loadInput(char overWrite);

void clearOutput();

#endif //LAB5_H_
